pro SWC_CAL_LASER_OFF


; uncomment this line to set default data directory
;path_DATA='/home/marco/PFS_PSA_OFFICIAL_ARCHIVE/MEX-M-PFS-2-EDR-EXT3-V1.0'

DEVICE, GET_DECOMPOSED=decomposed_state
     TVLCT, R1, G1, B1, /GET

DEVICE, DECOMPOSED=0

loadct,39


dir_sep = PATH_SEP()

IF KEYWORD_SET(path_DATA) eq 0 then file_MEAS=dialog_pickfile(TITLE="Select input file to read",PATH=path_Data,/MUST_EXIST, /READ, FILTER="*_RAW_SW.DAT") ELSE file_MEAS=dialog_pickfile (PATH =path_DATA,filter ='*_RAW_SW.DAT',GET_PATH =path_DATA)
path_DATA=File_dirname(file_MEAS)+dir_sep
file_MEAS=File_basename(file_MEAS)
temp_name=strsplit(file_MEAS, '.', /extract)
file_MEAS_LBL = temp_name(0)+'.LBL'
temp_name=strsplit(temp_name(0), '_', /extract)
if (float(temp_name(1)) le 633) then begin & print, 'ERROR: Laser-on orbit. Use SWC_CAL_LASER-ON.pro!' & stop & endif
file_HK = strjoin(temp_name(0:2),'_')+'_HK_'+temp_name(4)+'.DAT'
file_HK_LBL = strjoin(temp_name(0:2),'_')+'_HK_'+temp_name(4)+'.LBL'

;---------------------------------------------------------------------------
;-------------- Opening Hosekeeping File -----------------------------------

;    open_hk,file_HK,path_DATA,hk_struct

num = read_pfs_label(path_DATA+file_HK_LBL,'FILE_RECORDS')

hk_struct=read_pfs_hk(path_DATA+file_HK,num)

validIndex=0

if ((hk_struct(0).SCET_OBSERVATION_TIME ne 0) || (num gt 1))  then begin

          if (hk_struct(0).SCET_OBSERVATION_TIME eq 0) then validIndex = 1
;---------------------

    ;-------------- Plotting Some Hosekeeping Informations ------------

     temp_min = min(hk_struct(validIndex:num-2).T1_10V) <  min(hk_struct(validIndex:num-2).T5_10V) < min(hk_struct(validIndex:num-2).T8_10V)
     temp_max = max(hk_struct(validIndex:num-2).T1_10V) >  max(hk_struct(validIndex:num-2).T5_10V) > max(hk_struct(validIndex:num-2).T8_10V)

      window,0,title='Hosekeeping - SCET time vs. Internal Temperature', xsize=600, ysize=400
      plot,hk_struct(validIndex:num-2).SCET_OBSERVATION_TIME,hk_struct(validIndex:num-2).T1_10V,xs=1,ys=1,yr=[temp_min,temp_max],back=255,col=0,title='PFS Temperatures',xtitle='SCET (sec)',  ytitle='Temperature (K)', charsize=1.4, XTICKINTERVAL= 1000
      oplot,hk_struct(validIndex:num-2).SCET_OBSERVATION_TIME,hk_struct(validIndex:num-2).T5_10V,col=150
      oplot,hk_struct(validIndex:num-2).SCET_OBSERVATION_TIME,hk_struct(validIndex:num-2).T8_10V,col=240
	  XYOUTS, 0.20, 0.85, 'T1', charsize=1.5 ,charthick=1.5, color=0, /NORMAL
	  XYOUTS, 0.20, 0.80, 'T5', charsize=1.5 ,charthick=1.5, color=150, /NORMAL
	  XYOUTS, 0.20, 0.75, 'T8', charsize=1.5 ,charthick=1.5, color=240, /NORMAL

;---------------------------------------------------------------------------
;-------------- Opening Data File ------------------------------------------

    data_points = read_pfs_label(path_DATA+file_MEAS_LBL,'ITEMS')

    raw_struct=read_pfs_data(path_DATA+file_MEAS,num,data_points)

   ;-------------- Plotting Some Data --------------------------------

    points=N_ELEMENTS(raw_struct(0).interferogram)

    mean_range=indgen(200)+200

    yrange=[min(raw_struct.interferogram-mean(raw_struct.interferogram)), max(raw_struct.interferogram-mean(raw_struct.interferogram))]

    window,1,title='Raw Data'

    plot,indgen(2),xs=1, ys=1, xr=[0,points], yr=[yrange(0),yrange(1)],back=255,col=0, XTITLE='Sampling Point', YTITLE='Digital Number', TITLE='INTERFEROGRAMS' , /nodata
      for i=0,num-1 do begin
        temp=raw_struct(i).interferogram
        temp2=temp-mean(temp(mean_range))
         oplot,temp2,color=(float(i)/num)*255.*10
      endfor
;---------------------------------------------------------------------------

;---------------------------------------------------------------------------
;-------------- Opening Calibration Tables ---------------------------------

path_DATA = path_Data +'..'+ PATH_SEP()+'..'+ PATH_SEP()+'..'+ PATH_SEP()+'..'+PATH_SEP()
path_CAL_TABLES=dialog_pickfile(TITLE="Select CALIB (Calibration Curves) folder",PATH=path_Data,/MUST_EXIST, /DIR)+'SWC'+dir_sep+'LASER_OFF'+dir_sep

file_DS_FWD_CAL_RAW_SW   = 'PFS_DS-FWD_CAL_RAW_SW.DAT'
file_DS_REV_CAL_RAW_SW   = 'PFS_DS-REV_CAL_RAW_SW.DAT'
file_RESP_FWD_CAL_RAW_SW = 'PFS_RESP-FWD_CAL_RAW_SW.DAT'
file_RESP_REV_CAL_RAW_SW = 'PFS_RESP-REV_CAL_RAW_SW.DAT'

DS_FWD_CAL_RAW_SW = read_ascii(path_CAL_TABLES+file_DS_FWD_CAL_RAW_SW)
DS_REV_CAL_RAW_SW = read_ascii(path_CAL_TABLES+file_DS_REV_CAL_RAW_SW)
RESP_FWD_CAL_RAW_SW   = read_ascii(path_CAL_TABLES+file_RESP_FWD_CAL_RAW_SW  )
RESP_REV_CAL_RAW_SW   = read_ascii(path_CAL_TABLES+file_RESP_REV_CAL_RAW_SW  )

;get_lun,lun
;openw,lun,file_DS_FWD_CAL_RAW_SW
;printf,lun,DS_FWD_CAL_RAW_SW,format='(E20.7,"   ",E20.7)'
;close,lun
;free_lun,lun

    DS_FWD_CAL_RAW_SW = DS_FWD_CAL_RAW_SW.(0)
    DS_REV_CAL_RAW_SW = DS_REV_CAL_RAW_SW.(0)
    RESP_FWD_CAL_RAW_SW   =   RESP_FWD_CAL_RAW_SW.(0)
    RESP_REV_CAL_RAW_SW   =   RESP_REV_CAL_RAW_SW.(0)

    xrange=[1800,8300]
    window,2,title='Calibration Tables',xs=700,ys=600
    !P.MULTI=[0,2,2]
        plot,DS_FWD_CAL_RAW_SW(0,*),DS_FWD_CAL_RAW_SW(1,*),back=255,col=0,xs=1,xr=xrange, TITLE='Deep Space FWD' , XTITLE='Wavenumber (cm-1)', YTITLE='Intensity (DN)'
        plot,DS_REV_CAL_RAW_SW(0,*),DS_REV_CAL_RAW_SW(1,*),back=255,col=0,xs=1,xr=xrange, TITLE='Deep Space REV' , XTITLE='Wavenumber (cm-1)', YTITLE='Intensity (DN)'
        plot,  RESP_FWD_CAL_RAW_SW(0,*),  RESP_FWD_CAL_RAW_SW(1,*),back=255,col=0,xs=1,xr=xrange, TITLE='Responsivity FWD', XTITLE='Wavenumber (cm-1)', YTITLE='Responsivity (DN / erg s-1 cm-2 sr-1 / cm-1)'
        plot,  RESP_REV_CAL_RAW_SW(0,*),  RESP_REV_CAL_RAW_SW(1,*),back=255,col=0,xs=1,xr=xrange, TITLE='Responsivity REV', XTITLE='Wavenumber (cm-1)', YTITLE='Responsivity (DN / erg s-1 cm-2 sr-1 / cm-1)'
    !P.MULTI=0

;---------------------------------------------------------------------------
;-------------- Calibration ------------------------------------------------

          lambda        = 6.06520e-005*hk_struct.LDTEMPLW_10V +  1.19203
          spectral_step = 1.04149*(10000.00/(8192.00*lambda))
          x_axes        = indgen(points/2)
          x_axes        = Rebin(x_axes,points/2,num)
          x_axes        = x_axes*transpose(rebin(spectral_step,num,points/2))

         interferograms = raw_struct.interferogram
            Mean_Values = TOTAL(interferograms,1)/float(points)
                Mean_Values_rebinned=rebin(transpose(Mean_Values),points,num)
         interferograms = interferograms-Mean_Values_rebinned

         spectra        = abs(fft(interferograms,-1,DIMENSION=1))
            spectra     = spectra(0:points/2-1,*)
             spectra     = spectra/rebin(transpose(2^hk_struct.SWGAIN_STATUS),points/2,n_elements(hk_struct))  ;- SENSOR GAIN

         ;Double Pendulum direction: 0=Forward, 1=Reverse
         Forward        = where(hk_struct.DPDIR_STATUS eq 0)
         Reverse        = where(hk_struct.DPDIR_STATUS eq 1)

         Deep_space     = spectra
            Deep_space(*,Forward)=rebin(transpose((DS_FWD_CAL_RAW_SW(1,*))),points/2,n_elements(Forward))
            Deep_space(*,Reverse)=rebin(transpose((DS_REV_CAL_RAW_SW(1,*))),points/2,n_elements(Reverse))

         Responsivity   = spectra
            Responsivity(*,Forward)=rebin(transpose((RESP_FWD_CAL_RAW_SW(1,*))),points/2,n_elements(Forward))
            Responsivity(*,Reverse)=rebin(transpose((RESP_REV_CAL_RAW_SW(1,*))),points/2,n_elements(Reverse))

         MarsRadiance   = (Deep_space + spectra)/Responsivity

	yrange=[0,10]

    window,3,title='Calibrated Data',xs=900
         plot, indgen(2), color=0,back=255,xs=1,xr=[1800,8200],ys=1,yr=yrange, TITLE='Calibrated Spectra', XTITLE='Wavenumber (cm-1)', YTITLE='Radiance (erg s-1 cm-2 sr-1 / cm-1)' , charsize=1.4

            if (temp_name(2) eq 'MEAS') then begin

             for i=0,num-1 do oplot, x_axes(*,i), MarsRadiance(*,i), color=254*(i/float(num))
             for i=0,num-1 do print,hk_struct(i).SCET_OBSERVATION_TIME

			endif else begin

			 for i=1,num-2 do oplot, x_axes(*,i), MarsRadiance(*,i), color=254*(i/float(num))
             for i=1,num-2 do print,hk_struct(i).SCET_OBSERVATION_TIME

			endelse

endif  else if (STRMATCH(path_DATA+file_HK, '*CAL*')) then print,'FILE WITHOUT CALIBRATION MEASUREMENTS' else print, 'ERROR : FILE IS CORRUPTED '

;SCET = hk_struct(0:num-1).SCET_OBSERVATION_TIME  ;-- UINT  - 4 BYTES
;
;HELP,SCET_to_julian_time(SCET(0:num-1)),SCET,x_axes(*,0:num-1), MarsRadiance(*,0:num-1)

DEVICE, DECOMPOSED=decomposed_state
TVLCT, R1, G1, B1

stop

end