pro Data_Opener

     ; uncomment this line to set default data directory
     ;data_path='/home/marco/PFS_PSA_OFFICIAL_ARCHIVE/MEX-M-PFS-2-EDR-EXT3-V1.0/DATA/MARS/'


     DEVICE, GET_DECOMPOSED=decomposed_state
     TVLCT, R1, G1, B1, /GET

     DEVICE, DECOMPOSED=0

     loadct,39

     print, 'Running under '+!VERSION.OS_FAMILY+ ' environment'



     ;IF KEYWORD_SET(data_path) eq 0 then file=dialog_pickfile(TITLE="Select input file to read",/MUST_EXIST, /READ, FILTER=['*HK*.DAT','*RAW*.DAT']) else file=dialog_pickfile (PATH =data_path,filter =['*HK*.DAT','*RAW*.DAT'])
     IF KEYWORD_SET(data_path) eq 0 then file=dialog_pickfile(TITLE="Select input file to read",/MUST_EXIST, /READ, FILTER=['*HK*.DAT;*RAW*.DAT']) else file=dialog_pickfile (PATH =data_path,filter =['*HK*.DAT;*RAW*.DAT'])
     data_path=File_dirname(file)+PATH_SEP()
     file=File_basename(file)

     if STRMATCH(file, '*HK*') then begin

      open_hk,file,data_path,hk_struct

      num=n_elements(hk_struct.TYPEOFMES)

      validIndex=0

      if ((hk_struct(0).SCET_OBSERVATION_TIME ne 0) || (num gt 1))  then begin

       if (hk_struct(0).SCET_OBSERVATION_TIME eq 0) then validIndex = 1

       temp_min = min(hk_struct(validIndex:num-2).T1_10V) <  min(hk_struct(validIndex:num-2).T5_10V) < min(hk_struct(validIndex:num-2).T8_10V)
       temp_max = max(hk_struct(validIndex:num-2).T1_10V) >  max(hk_struct(validIndex:num-2).T5_10V) > max(hk_struct(validIndex:num-2).T8_10V)

       window,0,title='Housekeeping - SCET time vs. Internal Temperature', xsize=600, ysize=400
       plot,hk_struct(validIndex:num-2).SCET_OBSERVATION_TIME,hk_struct(validIndex:num-2).T1_10V,xs=1,ys=1,yr=[temp_min,temp_max],back=255,col=0,title='PFS Temperatures',xtitle='SCET (sec)',  ytitle='Temperature (K)', charsize=1.4, XTICKINTERVAL=2000
       oplot,hk_struct(validIndex:num-2).SCET_OBSERVATION_TIME,hk_struct(validIndex:num-2).T5_10V,col=150
       oplot,hk_struct(validIndex:num-2).SCET_OBSERVATION_TIME,hk_struct(validIndex:num-2).T8_10V,col=240
       XYOUTS, 0.20, 0.85, 'T1', charsize=1.5 ,charthick=1.5, color=0, /NORMAL
       XYOUTS, 0.20, 0.80, 'T5', charsize=1.5 ,charthick=1.5, color=150, /NORMAL
       XYOUTS, 0.20, 0.75, 'T8', charsize=1.5 ,charthick=1.5, color=240, /NORMAL
      endif else if (STRMATCH(file, '*CAL*')) then print,'FILE WITHOUT CALIBRATION MEASUREMENTS' else print, 'ERROR : FILE IS CORRUPTED '

     endif else begin


          open_raw,file,data_path,raw_struct

          num = N_ELEMENTS(raw_struct.OBT_OBSERVATION_TIME)

          validIndex = 0

          if ((raw_struct(0).SCET_OBSERVATION_TIME ne 0) || (num gt 1))  then begin

               if (raw_struct(0).SCET_OBSERVATION_TIME eq 0) then validIndex = 1

               points=N_ELEMENTS(raw_struct(validIndex).interferogram)

               mean_range=indgen(200)+200

               yrange=[min(raw_struct.interferogram-mean(raw_struct.interferogram)), max(raw_struct.interferogram-mean(raw_struct.interferogram))]

               window,1,title='Raw Data'
               plot,indgen(2),ys=1,xs=1,xr=[0,points], yr=[yrange(0),yrange(1)],back=255,col=0, XTITLE='Sampling Point', YTITLE='Digital Number', TITLE='INTERFEROGRAMS' , /nodata, charsize=1.3
               for i=validIndex,num-1 do begin
                    temp=raw_struct(i).interferogram
                    temp2=temp-mean(temp(mean_range))
                    oplot,temp2,color=(float(i)/num)*255.*10
               endfor

              endif  else if (STRMATCH(file, '*CAL*')) then print,'FILE WITHOUT CALIBRATION MEASUREMENTS' else print, 'ERROR : FILE IS CORRUPTED '

          endelse

          DEVICE, DECOMPOSED=decomposed_state
          TVLCT, R1, G1, B1

     stop

end